#
# ipquel.tcl - procedures for interactive Postquel using monitor
#
# $Header: /nfs/home/olive.s2k/src/base/local/tk/pgb3.0/lib/RCS/ipquel.tcl,v 1.1 1993/12/06 20:03:49 jimbo Exp $
#

# ---------------------------------------------------------------------------
# InteractivePQ - send interactive Postquel to the backend using "monitor"
# ---------------------------------------------------------------------------
proc InteractivePQ {} {
    global PGB

    if ![CheckDB] return

    if ![Tku_Edit "Postquel:" "" cmd] return
    if {[set cmd [string trim $cmd]] == ""} return
    if ![PQmonitor exec $cmd] {
	PQmonitor errbox "Postquel command failed."
    } else {
	if [Tku_Confirm "View results?"] {Tku_ViewFile [PQmonitor lastfile]}
    }
}

# ---------------------------------------------------------------------------
# PQmonitor - send Postquel to the backend somewhat like PQ but by
#	using the "monitor" shell program and temporary files
# ---------------------------------------------------------------------------
proc PQmonitor {cmd {a1 ""}} {
    global PQM PGB
    case $cmd in {
        exec {
	    PQmonitor reset
            set PQM(tmp) [Tku_Tmp]
            lappend monitor $PGB(Bin)/monitor -h [PQ host] \
                -p [PQ port] -c $a1 [PQ db] > $PQM(tmp)
            Log [join $monitor] Monitor
            Tku_Working
            if [catch {eval exec $monitor} err] {
                Log $err Error
                set PQM(errmsg) $err
                set PQM(status) 0
            } else {
		set PQM(nlines) [exec wc -l $PQM(tmp)]
		Log "$PQM(nlines) lines" Success
		set PQM(status) 1
	    }
            Tku_Waiting
	    return $PQM(status)
        }
	lastfile {
	    if [info exists PQM(tmp)] {return $PQM(tmp)} else {return ""}
	}
	reset {
	    if [info exists PQM(tmp)] {exec rm -f $PQM(tmp)}
	    catch {unset PQM}
	}
        errbox {
	    case $PQM(status) in {
	    0 	{Tku_Error "$a1\n\nPostgres error:\n\n$PQM(errmsg)"}
	    1	{Tku_Notice "$a1\n\nPostquel successful"}
	    default {Tku_Error "$a1\n\nUnknown status: $PQM(status)"}
	    }
	}
        default {
            error "PQmonitor: unknown command:  $cmd"
        }
    }
}
